#include <bits/stdc++.h>

using namespace std;

int read_int_safely() {
    int tmp;
    cin >> tmp;
    if (!cin) exit(0);
    return tmp;
}

int query(int I, int J, int K) {
    cout << "? " << I << ' ' << J << ' ' << K << endl;
    return read_int_safely();
}

void answer(const vector<int> &g) {
    cout << "!";
    for (int x : g) {
        cout << ' ' << x;
    }
    cout << endl;
}

void solve() {
    int N = read_int_safely();

    int tmp = query(0, 1, 2);

    vector<int> g(N);

    answer(g);
}

int main() {
    int T = read_int_safely();
    for (int t = 0; t < T; ++t) {
        solve();
    }
    return 0;
}
